From: Ross Burton <ross.burton@intel.com>
To: openembedded-core@lists.openembedded.org
Subject: [PATCH 2/3] postinst: fix and simplify the postinst test recipe
Date: Wed, 22 Nov 2017 16:04:13 +0000 [thread overview]
Message-ID: <20171122160414.14093-2-ross.burton@intel.com> (raw)
In-Reply-To: <20171122160414.14093-1-ross.burton@intel.com>
Reduce the number of packages, and fix some syntax and logic errors in the
scripts.
Signed-off-by: Ross Burton <ross.burton@intel.com>
---
.../recipes-test/postinst/postinst_1.0.bb | 158 +++++++--------------
1 file changed, 51 insertions(+), 107 deletions(-)
diff --git a/meta-selftest/recipes-test/postinst/postinst_1.0.bb b/meta-selftest/recipes-test/postinst/postinst_1.0.bb
index 6d497342779..112aa08c80f 100644
--- a/meta-selftest/recipes-test/postinst/postinst_1.0.bb
+++ b/meta-selftest/recipes-test/postinst/postinst_1.0.bb
@@ -1,126 +1,70 @@
+SUMMARY = "Packages to exercise postinstall functions"
LICENSE = "MIT"
-ALLOW_EMPTY_${PN}-at-rootfs = "1"
+
+inherit allarch
+
+PACKAGES = "${PN}-rootfs ${PN}-delayed-a ${PN}-delayed-b"
+
+ALLOW_EMPTY_${PN}-rootfs = "1"
ALLOW_EMPTY_${PN}-delayed-a = "1"
ALLOW_EMPTY_${PN}-delayed-b = "1"
-ALLOW_EMPTY_${PN}-delayed-d = "1"
-ALLOW_EMPTY_${PN}-delayed-p = "1"
-ALLOW_EMPTY_${PN}-delayed-t = "1"
-
-PACKAGES += "${PN}-at-rootfs ${PN}-delayed-a ${PN}-delayed-b ${PN}-delayed-d ${PN}-delayed-p ${PN}-delayed-t"
-PROVIDES += "${PN}-at-rootfs ${PN}-delayed-a ${PN}-delayed-b ${PN}-delayed-d ${PN}-delayed-p ${PN}-delayed-t"
-FILES_${PN}-delayed-a = ""
-FILES_${PN}-delayed-b = ""
-FILES_${PN}-delayed-d = ""
-FILES_${PN}-delayed-p = ""
-FILES_${PN}-delayed-t = ""
-
-# Runtime dependencies
-RDEPENDS_${PN}-delayed-a = "${PN}-at-rootfs"
+
+RDEPENDS_${PN}-delayed-a = "${PN}-rootfs"
RDEPENDS_${PN}-delayed-b = "${PN}-delayed-a"
-RDEPENDS_${PN}-delayed-d = "${PN}-delayed-b"
-RDEPENDS_${PN}-delayed-p = "${PN}-delayed-d"
-RDEPENDS_${PN}-delayed-t = "${PN}-delayed-p"
-
-# Main recipe post-install
-pkg_postinst_${PN}-at-rootfs () {
- tfile="/etc/postinsta-test"
- touch "$D"/this-was-created-at-rootfstime
- if test "x$D" != "x" then
- # Need to run on first boot
+
+TESTDIR = "${sysconfdir}/postinst-test"
+
+# At rootfs time touch $TESTDIR/rootfs. Errors if the file already exists, or
+# if the function runs on first boot.
+pkg_postinst_${PN}-rootfs () {
+ set -e
+
+ if [ -z "$D" ]; then
+ echo "${PN}-rootfs should have finished at rootfs time"
+ exit 1
+ fi
+
+ if [ -e $D${TESTDIR}/rootfs ]; then
+ echo "$D${TESTDIR}/rootfs exists, but should not"
exit 1
- else
- echo "lets write postinst" > $tfile
fi
+
+ mkdir -p $D${TESTDIR}
+ touch $D${TESTDIR}/rootfs
}
-# Dependency recipes post-installs
+# Depends on rootfs, delays until first boot, verifies that the rootfs file was
+# written.
pkg_postinst_${PN}-delayed-a () {
- efile="/etc/postinst-test"
- tfile="/etc/postinsta-test"
- rdeps="postinst"
-
- if test "x$D" != "x"; then
- # Need to run on first boot
- exit 1
- else
- touch /etc/this-was-created-at-first-boot
- if test -e $efile ; then
- echo 'success' > $tfile
- else
- echo 'fail to install $rdeps first!' >&2
+ set -e
+
+ if [ -n "$D" ]; then
+ echo "Delaying ${PN}-delayed-a until first boot"
exit 1
- fi
- fi
-}
+ fi
-pkg_postinst_${PN}-delayed-b () {
- efile="/etc/postinsta-test"
- tfile="/etc/postinstb-test"
- rdeps="postinsta"
-
- if test "x$D" != "x"; then
- # Need to run on first boot
- exit 1
- else
- if test -e $efile ; then
- echo 'success' > $tfile
- else
- echo 'fail to install $rdeps first!' >&2
+ if [ ! -e ${TESTDIR}/rootfs ]; then
+ echo "${PN}-delayed-a: ${TESTDIR}/rootfs not found"
exit 1
- fi
- fi
+ fi
+
+ touch ${TESTDIR}/delayed-a
}
-pkg_postinst_${PN}-delayed-d () {
- efile="/etc/postinstb-test"
- tfile="/etc/postinstd-test"
- rdeps="postinstb"
-
- if test "x$D" != "x"; then
- # Need to run on first boot
- exit 1
- else
- if test -e $efile ; then
- echo 'success' > $tfile
- else
- echo 'fail to install $rdeps first!' >&2
+# Depends on delayed-a, delays until first boot, verifies that the delayed-a file was
+# written. This verifies the ordering between delayed postinsts.
+pkg_postinst_${PN}-delayed-b () {
+ set -e
+
+ if [ -n "$D" ]; then
+ echo "Delaying ${PN}-delayed-b until first boot"
exit 1
- fi
- fi
-}
+ fi
-pkg_postinst_${PN}-delayed-p () {
- efile="/etc/postinstd-test"
- tfile="/etc/postinstp-test"
- rdeps="postinstd"
-
- if test "x$D" != "x"; then
- # Need to run on first boot
- exit 1
- else
- if test -e $efile ; then
- echo 'success' > $tfile
- else
- echo 'fail to install $rdeps first!' >&2
+ if [ ! -e ${TESTDIR}/delayed-a ]; then
+ echo "${PN}-delayed-b: ${TESTDIR}/delayed-a not found"
exit 1
- fi
- fi
-}
+ fi
-pkg_postinst_${PN}-delayed-t () {
- efile="/etc/postinstp-test"
- tfile="/etc/postinstt-test"
- rdeps="postinstp"
-
- if test "x$D" != "x"; then
- # Need to run on first boot
- exit 1
- else
- if test -e $efile ; then
- echo 'success' > $tfile
- else
- echo 'fail to install $rdeps first!' >&2
- exit 1
- fi
- fi
+ touch ${TESTDIR}/delayed-b
}
--
2.11.0
next prev parent reply other threads:[~2017-11-22 16:04 UTC|newest]
Thread overview: 9+ messages / expand[flat|nested] mbox.gz Atom feed top
2017-11-22 16:04 [PATCH 1/3] oeqa/commands: don't break if get_bb_vars is passed a tuple Ross Burton
2017-11-22 16:04 ` Ross Burton [this message]
2017-11-22 16:09 ` [PATCH 2/3] postinst: fix and simplify the postinst test recipe Alexander Kanavin
2017-11-22 16:09 ` Burton, Ross
2017-11-22 16:13 ` Alexander Kanavin
2017-11-22 16:04 ` [PATCH 3/3] oeqa/selftest/runtime_test: simplify postinst testing Ross Burton
2017-11-23 1:34 ` Joshua Lock
2017-11-23 10:21 ` Burton, Ross
2017-11-23 12:08 ` Burton, Ross
Reply instructions:
You may reply publicly to this message via plain-text email
using any one of the following methods:
* Save the following mbox file, import it into your mail client,
and reply-to-all from there: mbox
Avoid top-posting and favor interleaved quoting:
https://en.wikipedia.org/wiki/Posting_style#Interleaved_style
* Reply using the --to, --cc, and --in-reply-to
switches of git-send-email(1):
git send-email \
--in-reply-to=20171122160414.14093-2-ross.burton@intel.com \
--to=ross.burton@intel.com \
--cc=openembedded-core@lists.openembedded.org \
/path/to/YOUR_REPLY
https://kernel.org/pub/software/scm/git/docs/git-send-email.html
* If your mail client supports setting the In-Reply-To header
via mailto: links, try the mailto: link
Be sure your reply has a Subject: header at the top and a blank line
before the message body.
This is a public inbox, see mirroring instructions
for how to clone and mirror all data and code used for this inbox